/**
 *  Learnville Street Room
 *  @author Drakkos
 *  @started 08/10/2008
 *
 *  If you change this file, please also update it in LPC for Dummies.
 *
 */

#include "path.h"

inherit "/std/room/outside";

void setup() {
  set_short ("southeast corner of the marketplace");
  add_property ("determinate", "the ");
   
  set_long ("This is a skeleton room.\n");

  set_light (100);

  add_zone ("learnville");
  
  add_exit ("north", ROOMS + "market_northeast", "path");
  add_exit ("east", ROOMS + "magic_shop", "door");
  add_exit ("west", ROOMS + "market_southwest", "path");
  add_exit ("northwest", ROOMS + "market_northwest", "path");

  // We're going to set an exit function.  Any time someone 
  // attempts to take this exit, the warn_player method will be 
  // called.  If it returns 1, exit is permitted.  If it returns 
  // 0, then exit is not permitted.
  modify_exit ("east", 
    ({
      "function", "warn_player"
    })
  );
  modify_exit ("northwest", ({"obvious", 0}));

  
  set_linker ( ({ 
    ROOMS + "market_northwest",
    ROOMS + "market_northeast",
    ROOMS + "market_southwest",
  }) );

}

// This is the method that gets called when anyone attempts to take the 
// east exit.
int warn_player (string direction, object ob, string special_mess) {
  // Let's check to see if they have the property set on them.
  if (ob->query_property ("been warned about grues") == 1) {
    // If they do have the property set, return 1 and let them 
    // take the exit.
    return 1;
  }
  
  // Send them a warning message.
  tell_object (ob, "The room ahead smells of grues... are you sure you "
    "want to risk it?\n");
  // Make sure that the normal failure message is suppressed.
  notify_fail ("");
  // Add a property to the player so that if they choose to take 
  // the exit again, they'll be able to go through.  We add it with 
  // a timer of 120 seconds.
  ob->add_property ("been warned about grues", 1, 120);
  // Stop them taking the exit this time through.
  return 0;
}